﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace IGDocumentation
{
    public class CarsBusinessLogic
    {
        public ObservableCollection<Car> GetCars()
        {
            ObservableCollection<Car> carList = new ObservableCollection<Car>();
            carList.Add(new Car("Dodge", 22, 153, 20));
            carList.Add(new Car("Ford", 27, 96, 30));
            carList.Add(new Car("BMW", 35, 42, 40));
            carList.Add(new Car("Toyota", 20, 131, 50));

            return carList;
        }
    }

    public class Car : INotifyPropertyChanged
    {
        string m_make;
        int m_baseprice;
        int m_mileage;
        int m_capacity;



        public Car()
        {
        }

        public Car(string make, int baseprice, int mileage, int capacity)
        {
            this.Make = make;
            this.BasePrice = baseprice;
            this.Mileage = mileage;
            this.Capacity = capacity;
        }

        public string Make
        {
            get { return m_make; }
            set
            {
                if (m_make != value)
                {
                    m_make = value;
                    OnPropertyChanged("Make");
                }
            }
        }



        public int BasePrice
        {
            get { return m_baseprice; }
            set
            {
                if (m_baseprice != value)
                {
                    m_baseprice = value;
                    OnPropertyChanged("BasePrice");
                }
            }
        }

        public int Mileage
        {
            get { return m_mileage; }
            set
            {
                if (m_mileage != value)
                {
                    m_mileage = value;
                    OnPropertyChanged("Mileage");
                }
            }
        }

        public int Capacity
        {
            get { return m_capacity; }
            set
            {
                if (m_capacity != value)
                {
                    m_capacity = value;
                    OnPropertyChanged("Capacity");
                }
            }

        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }

}